// Generated by the WOLips Templateengine Plug-in at 14 févr. 2011 13:32:39

/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.physalisw.serveur.components;

import org.cocktail.cocowork.server.metier.convention.Contrat;
import org.cocktail.cocowork.server.metier.convention.ContratPartenaire;
import org.cocktail.fwkcktlpersonne.common.metier.EOAssociation;
import org.cocktail.fwkcktlpersonne.common.metier.EOIndividu;
import org.cocktail.fwkcktlpersonne.common.metier.EORepartAssociation;
import org.cocktail.fwkcktlpersonne.common.metier.EORepartStructure;
import org.cocktail.fwkcktlpersonne.common.metier.EORepartTypeGroupe;
import org.cocktail.fwkcktlpersonne.common.metier.EOSecretariat;
import org.cocktail.fwkcktlpersonne.common.metier.EOStructure;
import org.cocktail.fwkcktlrecherche.server.metier.EODirecteurThese;
import org.cocktail.fwkcktlrecherche.server.metier.EODoctorant;
import org.cocktail.fwkcktlrecherche.server.metier.EODoctorantThese;
import org.cocktail.physalisw.serveur.components.common.PhysalisWOComponent;
import org.cocktail.physalisw.serveur.components.controlers.AccueilCtrl;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOContext;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSMutableArray;
import com.webobjects.foundation.NSTimestamp;

import er.extensions.eof.ERXQ;
import er.extensions.qualifiers.ERXKeyValueQualifier;

/**
 * Page d'accueil de l'application
 */
public class Accueil extends PhysalisWOComponent {
    
    private static final long serialVersionUID = 6071653145328505763L;

	private AccueilCtrl ctrl;
	
	private Integer numero;

	private Boolean isOpenFenetreException = Boolean.FALSE;
	
	private static final String TGRP_CODE_LABORATOIRE = "LA";
	
	/**
	 * Contructeur
	 * @param context contexte
	 */
	public Accueil(WOContext context) {
        super(context);
        ctrl = new AccueilCtrl(this);
        setCtrl(ctrl);
    }

	/**
	 * @return boolean isCreerDisabled
	 */
	public boolean isCreerDisabled() {
		boolean isCreerDisabled = false;
		// TODO Ajouter le code correspondant
		
		return isCreerDisabled;
	}
	
	/**
	 * @return page de recherche avancee
	 */
	public WOActionResults rechercheAvancee() {
		// TODO Ajouter le code pour renvoyer la page de recherche avancee
		return null;
	}


	/**
	 * @return the ctrl
	 */
	public AccueilCtrl ctrl() {
		return ctrl;
	}

	/**
	 * @param ctrl the ctrl to set
	 */
	public void setCtrl(AccueilCtrl ctrl) {
		this.ctrl = ctrl;
	}

	/**
	 * @return the numero
	 */
	public Integer numero() {
		return numero;
	}

	/**
	 * @param numero the numero to set
	 */
	public void setNumero(Integer numero) {
		this.numero = numero;
	}

	/**
	 * @return the isOpenFenetreException
	 */
	public Boolean isOpenFenetreException() {
		return isOpenFenetreException;
	}

	/**
	 * @param isOpenFenetreException the isOpenFenetreException to set
	 */
	public void setIsOpenFenetreException(Boolean isOpenFenetreException) {
		this.isOpenFenetreException = isOpenFenetreException;
	}

	/**
	 * @return la page de recherche d'un doctorant
	 */
	public WOActionResults chercheDoctorant() {
		ChercheDoctorant cd = (ChercheDoctorant) pageWithName(ChercheDoctorant.class.getName());
		session().setPageIntermediaire(cd);
		session().setLibellePageIntermediaire("Recherche d'un doctorant");
		return cd;
	}
	
	/**
	 * @return la page de recherche d'un individu
	 */
	public WOActionResults chercheIndividu() {
		ChercheIndividu ci = (ChercheIndividu) pageWithName(ChercheIndividu.class.getName());
		return ci;
	}
	
	/**
	 * @return la page avec toutes les thèses 
	 */
	public WOActionResults toutesLesTheses() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		session().setPageIntermediaire(page);
		return page;
	}
	
	/**
	 * @return la page avec les theses en cours
	 */
	public WOActionResults thesesEnCours() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(
				ERXQ.and(
						ERXQ.or(EODoctorantThese.DATE_SOUTENANCE.isNull(), EODoctorantThese.DATE_SOUTENANCE.after(new NSTimestamp())),
						EODoctorantThese.DATE_FIN_ANTICIPEE.isNull()
						)
					);
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}
	
	/**
	 * @return la page avec les theses soutenues
	 */
	public WOActionResults thesesSoutenues() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		page.setIsListeThesesSoutenues(true);
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(ERXQ.and(EODoctorantThese.DATE_SOUTENANCE.isNotNull(), EODoctorantThese.DATE_SOUTENANCE.before(new NSTimestamp())));
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}
	
	/**
	 * @return la page avec les theses abandonnees
	 */
	public WOActionResults thesesAbandonnees() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		page.setIsListeThesesAbandonnees(true);
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(EODoctorantThese.DATE_FIN_ANTICIPEE.isNotNull());
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}
	
	/**
	 * @return la page avec les thèses dirigées par la personne connectée
	 */
	public WOActionResults thesesDirigees() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(qualifierDoctorant());
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}

	private ERXKeyValueQualifier qualifierEncadrant() {
	    return EODoctorantThese.TO_DIRECTEURS_THESE.dot(
				EODirecteurThese.TO_CONTRAT_PARTENAIRE_CW.dot(
				ContratPartenaire.PERS_ID)).eq(session().applicationUser().getPersId());
    }

	/**
	 * @return la page avec les thèses de la personne connectee
	 */
	public WOActionResults thesesDoctorant() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(qualifierDoctorant());
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}

	private ERXKeyValueQualifier qualifierDoctorant() {
	    return EODoctorantThese.TO_DOCTORANT.dot(
				EODoctorant.TO_INDIVIDU_FWKPERS.dot(
				EOIndividu.PERS_ID)).eq(session().applicationUser().getPersId());
    }
	
	/**
	 * @return la page avec les thèses du laboratoire de la personne connectée (directeur laboratoire ou secretaire)
	 */
	public WOActionResults thesesLaboratoire() {
		return thesesResponsableOuSecretaireStructure(factoryAssociation().laboratoireTheseAssociation(edc()));
	}
	
	/**
	 * @return la page avec les thèses de l'ecole doctorale de la personne connectée (directeur laboratoire ou secretaire)
	 */
	public WOActionResults thesesED() {
		return thesesResponsableOuSecretaireStructure(factoryAssociation().ecoleDoctoraleAssociation(edc()));
	}
	
	private WOActionResults thesesResponsableOuSecretaireStructure(EOAssociation association) {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(qualifierResponsableOuSecretaireStructure(association));
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}

	private EOQualifier qualifierResponsableOuSecretaireStructure(EOAssociation association) {
	    NSArray<EORepartAssociation> repartAssociation = 
				EORepartAssociation.fetchAll(edc(), EORepartAssociation.TO_ASSOCIATION.eq(association));
		
		NSMutableArray<EOStructure> structures = new NSMutableArray<EOStructure>();
		
		for (EORepartAssociation ra : repartAssociation) {
			EOIndividu responsable = ra.toStructuresAssociees().get(0).toResponsable();
			NSArray<EOSecretariat> secretaires = ra.toStructuresAssociees().get(0).toSecretariats();
			
			if (responsable != null && responsable.persId().equals(session().applicationUser().getPersId())) { 
				structures.add(ra.toStructure());
			}
			
			for (EOSecretariat secretaire : secretaires) {
				if (secretaire.toIndividu().persId().equals(session().applicationUser().getPersId())) {
					structures.add(ra.toStructure());
				}
			}
			
		}
		
		EOQualifier qualifier = EODoctorantThese.TO_CONTRAT.dot(Contrat.GROUPE_PARTENAIRE).in(structures);
	    return qualifier;
    }
	
	/**
	 * @return la page avec les theses du (des) laboratoire(s) auquel la personne connectée est membre
	 */
	public WOActionResults thesesMembreLaboratoire() {
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(qualifierMembresLaboratoire());
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		return page;
	}

	private EOQualifier qualifierMembresLaboratoire() {
	    NSArray<EOStructure> structuresMembre = EOStructure.fetchAll(edc(), EOStructure.TO_REPART_TYPE_GROUPES.dot(EORepartTypeGroupe.TGRP_CODE_KEY).eq(TGRP_CODE_LABORATOIRE));
		NSMutableArray<Integer> persId = new NSMutableArray<Integer>();
		NSMutableArray<EOStructure> structures = new NSMutableArray<EOStructure>();
		
		for (EOStructure structure : structuresMembre) {
			NSArray<EORepartStructure> rs = structure.toRepartStructuresElts();
			for (EORepartStructure unRs : rs) {
				if (session().applicationUser().getPersId().equals(unRs.toPersonneElt().persId())) {
					persId.add(structure.persId());
				}
			}
		}
		
		NSArray<EORepartAssociation> repartAssociation = EORepartAssociation.fetchAll(edc(), EORepartAssociation.PERS_ID.in(persId));
		
		for (EORepartAssociation ra : repartAssociation) {
			if (!structures.contains(ra.toStructure())) {
				structures.add(ra.toStructure());
			}
		}
		
		return EODoctorantThese.TO_CONTRAT.dot(Contrat.GROUPE_PARTENAIRE).in(structures);
    }
	
	/**
	 * @return la page avec les theses visibles pour la personne connectée
	 */
	public WOActionResults thesesVisibles() {
		NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
		qualifiers.add(qualifierDoctorant());
		qualifiers.add(qualifierEncadrant());
		qualifiers.add(qualifierMembresLaboratoire());
		qualifiers.add(qualifierResponsableOuSecretaireStructure(factoryAssociation().ecoleDoctoraleAssociation(edc())));
		qualifiers.add(qualifierResponsableOuSecretaireStructure(factoryAssociation().laboratoireTheseAssociation(edc())));
		
		ListeTheses page = (ListeTheses) pageWithName(ListeTheses.class.getName());
		page.setQualifiers(qualifiers);
		session().setPageIntermediaire(page);
		
		return page;
	}
	
	/**
	 * @return la page des gestions de données
	 */
	public WOActionResults gestionDonnees() {
		GestionDonneesPhysalis page = (GestionDonneesPhysalis) pageWithName(GestionDonneesPhysalis.class.getName());
		session().setPageIntermediaire(page);
		return page;
	}
	
	/**
	 * @return la page des enquetes siredo
	 */
	public WOActionResults enquetesSiredo() {
		EnquetesSiredo page = (EnquetesSiredo) pageWithName(EnquetesSiredo.class.getName());
		session().setPageIntermediaire(page);
		return page;
	}
	
}
